<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托商:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" name="entrustCode" placeholder="请输入委托编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <keep-alive>
      <!-- eslint-disable-next-line vue/require-component-is -->
      <component ref="refModal" :is="currentComponent" @on-result-change="_componentResult"></component>
    </keep-alive>
  </div>
</template>
<script>
import { soilEntrust } from '../../../api'
import http from '../../../api/http'
import Operation from '../../../components/operation/Operation'
import global from '../../../api/config'
import SampleManage from './SampleManage'
import SamplePreparationEdit from './SamplePreparationEdit'
export default {
  components: {
    // eslint-disable-next-line vue/no-unused-components
    Operation,
    // eslint-disable-next-line vue/no-unused-components
    SamplePreparationEdit,
    // eslint-disable-next-line vue/no-unused-components
    SampleManage
  },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: false,
      btn: [],
      iconMsg: [
        {
          type: 'ios-list',
          id: '',
          name: '试样列表'
        },
        {
          type: 'ios-download',
          id: '',
          name: '导出开土制备记录'
        },
        {
          type: 'ios-camera-outline',
          id: '',
          name: '试样照片'
        },
        {
          type: 'md-cloud',
          id: '',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: '',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        contractCode: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托商', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托日期', key: 'entrustDate', width: 120, date: true },
        { title: '钻孔位置', key: 'boreholeLocation', width: 120 },
        { title: '水深（米）', key: 'waterDepth', width: 120 },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        // { title: '平均容重', key: 'projectNo', width: 120 },
        // { title: '报告编号', key: 'reportCode', width: 120 },
        { title: '制表日期', key: 'tabulateDate', width: 120, date: true },
        { title: '制表人', key: 'tabulater', width: 120 },
        // { title: '批准日期', key: 'approveDate', width: 120, date: true },
        // { title: '批准人', key: 'approver', width: 120 },
        { title: '检验类别', key: 'testType', width: 120 }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case '提交至评审':
            this._submitToReview()
            break
          case '提交':
            this._submitToSkipReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            this._editModal(true, data.id)
            break
          case '导出开土制备记录':
            this._exportPrepare(data.id)
            break
          case '试样列表':
            this._sampleManage(data.id)
            break
          case '试样照片':
            this._uploadPhoto(data)
            break
          case '附件':
            this._upload(data.id)
            break
          case '导出委托单':
            this._exportEntrust(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _componentResult(data, msg) {
      switch (this.currentComponent) {
        default:
          this._page()
      }
    },
    _exportPrepare(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出这条记录',
        onOk: () => {
          window.open(
            global.baseURL +
              '/soil/v1/entrust/export_soil_prepare_record?ids=' +
              id,
            '_blank'
          )
        }
      })
    },
    _sampleManage(data) {
      // 管理样品
      this.currentComponent = 'SampleManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(data)
      })
      // this.$refs.sampleManageModal._open(data)
    },
    _submitToReview() {
      this._submitByContractIds('委托评审')
    },
    _submitToSkipReview() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要提交 ' + ids.length + ' 条记录？',
          onOk: () => {
            this._subToSkipRe(ids)
          }
        })
      }
    },

    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            this._subToRe(ids)
          }
        })
      }
    },
    _subToRe: async function(ids) {
      const result = await soilEntrust.submit(ids)
      if (result) {
        this._resultChange('提交成功')
      }
    },

    _subToSkipRe: async function(ids) {
      const result = await soilEntrust.submitSkipReview(ids)
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    _record(id) {
      this.currentComponent = 'Operation'
      this.$nextTick(() => {
        this.$refs.refModal._open(id)
      })
      // this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'page':
          this._page()
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await soilEntrust.pageSamplePrepareCheck(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editModal._open()
      }
    },
    _uploadPhoto(data) {
      // 上传照片文件
      this.currentComponent = 'PhotoManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(data.id, 'entrustId')
      })
      // this.$refs.PhotoManage._open(id, 'entrustId')
    },
    _upload(id) {
      // 上传照片文件
      this.currentComponent = 'FileManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(id, 'entrustId')
      })
      // this.$refs.FileManage._open(id, 'entrustId')
    },
    _exportEntrust(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出委托单？',
        onOk: () => {
          http.open('/meter/v1/entrust/export_send_entrust/?id=' + id)
        }
      })
    },

    _getById: async function(id) {
      const result = await soilEntrust.getVOById(id)
      if (result) {
        this.$refs.editModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await soilEntrust.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
